//Lab 4
//Sajeev Sivanesan
//CSC 123

#include<math.h>//used for math functions
#include<stdio.h>//used for I/O
#include<conio.h>//used for clear screen
#include<stdlib.h>//used for exit function
#include<dos.h>//used for sleep function

//prototypes
void menu (void);//function to call the parent functions, user selection
float tomorrow (float, float, float); //function to compute future values
float today (float, float, float);//function to compute present value
float number (float, float, float);//function to compute years
float percent_interest (float, float, float);//function to compute percent
void print_ans(float, float, float, float, float, char);//function to print answers
int again(int in);//function to decide repeat status
int parent_future(char in_char);//function to interrogate user for future solution
int parent_present(char in_char);//function to interrogate user for present solution
int parent_interest(char in_char);//function to interrogate user for interest solution
int parent_years(char in_chat);//function to interrogate user for years solution

/*Function main's only purpose in the program is to call the menu
   function to get the program started.  The menu function calls the
   appropriate parent function.  The parent function(s) in the program
   do most of the function calling and parameter passing in the program.
   The four parent functions are identical in code except for the computational
   function they call.*/

void main()
{//begin of main function
    menu();

}//end of main


void menu()
{//begin of menu function
int menu, in;  //variable declaration
float answer, future, present, interest, years;  //variable declarations
char in_char;  //char declaration
//clrscr();  //clear screen
in = 0;
    while (in != 1) //Menu loop, while loop (a)
   { //begining of while loop (a)
    fflush(stdin);
//    clrscr();
    printf("Please select one of the following functions to solve for.\n\n\n");
//prompts user for input
    printf("Press (F) for Future value.\n\n");
    printf("Press (P) for Present value.\n\n");
    printf("Press (I) for Percent interest.\n\n");
    printf("Press (N) for Number of years.\n\n");
    in_char = getch();//obtains user input
    in = 1;//intializes i for running of loop (b)
      while (in == 1) //Used for repeating the same process, while loop (b)
       {
	switch (in_char)//(case)(#) is the asci value representing a input letter

	    {  //begin of in_char switch
	    case 102:// Future Value was selected (F)
		in = parent_future(in_char);
		break;

		case 112://present value was selected (P)
		in = parent_present(in_char);
		break;

		case 105://interest rate value was selected (I)
		in = parent_interest(in_char);
		break;

	       case 110://number of years was selected (N)
	       in = parent_years(in_char);
	       break;

                  default://invalid input, restarts program
		   in = 0;//resets in so loop (b) tests false, loop a will test true(restart)
		   break;
	   }//end of in_char switch

       }//end of while loop (b)
   }//end of while loop (a)
}//end of menu


/*Function to ask user input values, calls the computation function tommorrow,
    calls print answer to print the answer, calls the again function to set the-----
    variable in (for repeating), returns in to the menu function.-------------------
     pre: in_char..................................................................................................
     post: in......................................................................................................*/

int parent_future(char in_char)//called from menu

{ //begining of parent_future function
float present, interest, years, answer, future;
int in;
		// clrscr();
		   printf("SOLVING FOR FUTURE VALUE\n\n\n"); //start of user input
		   printf("Enter your present value\n");//prompts user for input
		   scanf("%f", &present);//enters input into memory
		   printf("Enter the amount of interest to figure the future value\n");
		   scanf ("%f", &interest);
		   printf("Enter the amount of years\n");
		   scanf("%f", &years);
                           //function call to compute and return answer
		   answer = tomorrow(present, interest, years);
                          //function call to print answer
		   print_ans(answer, present, interest, years, future, in_char);
		   in = again(in);//calls function to determine repeat status
		   return(in);//returns (in) to menu function
}//end of future function


/*Function to obtain values to compute present.  Calls the function today to compute
   the answer.  Calls the function print to output answers to the screen.  Calls the again
   function to determine if the user would like to repeat.
    pre: in_char
    post: in
*/

int parent_present(char in_char)//called from menu

{ //begining of parent_present function
float future, interest, years, answer, present;
int in;


//		   clrscr();
		   printf("SOLVING FOR PRESENT VALUE\n\n\n");
		   printf("Enter your future value\n");//prompts user
		   scanf("%f", &future);//enters input into memory
		   printf("Enter the amount of interest to figure the present value\n");
		   scanf ("%f", &interest);
		   printf("Enter the amount of years\n");
		   scanf("%f", &years);
                         //call of today function to compute and return the present value
		   answer = today(future, interest, years);
                           //call of the print function to print answers
		   print_ans(answer, present, interest, years, future, in_char);
		   in = again(in);//calls the again function to determine repeat status
			   return(in);//returns (in) to menu function
}//end of parent_present function


/*Function to obtain values to compute interest value.  Function calls percent to
   compute answers.  Calls print to output answer to the screen.  Calls again to
   determine repeat status.  Returns a value in to menu.
   pre: in_char
   post: in
*/


int parent_interest(char in_char)//called from menu


{//begining of parent_interest function
float future, present, years, answer, interest;
int in;


//		      clrscr();
		   printf("SOLVING FOR INTEREST RATE\n\n\n");
		   printf("Enter your present value\n");//prompt user for input
		   scanf("%f", &present);//obtains user input into memory
		   printf("Enter your future value\n");
		   scanf ("%f", &future);
		   printf("Enter the amount of years\n");
		   scanf("%f", &years);
                           //call of the percent_interest function to compute interest
		   answer = percent_interest(present, future, years);
                           //call of the print function to print answers
		   print_ans(answer, present, interest, future, years, in_char);
		   in = again(in);//call of again to determine repeat status
		   return(in);//returns (in) to menu function

}//end of parent_interest function


/*Function to obtain values to compute the years value.  Calls function answer
   to compute answer.  Calls funtion print to print answer.  Calls the again function
   to determine repeat status.
   pre: in_char
   post: in
*/

int parent_years(char in_char)//called from menu
{//begining of parent_years function
float future, present, interest, answer, years;
int in;


		//	  clrscr();
		   printf("SOLVING FOR THE NUMBER OF YEARS\n\n\n");
		   printf("Enter your present value\n");//prompts user
		   scanf("%f", &present);//obtain user input
		   printf("Enter the amount of interest to figure the future value\n");
		   scanf ("%f", &interest);
		   printf("Enter your future value\n");
		   scanf("%f", &future);
                           //calls number function to compute number of years
		   answer = number(present, interest, future);
                           //calls print function to print the answer
		   print_ans(answer, present, interest, years, future, in_char);
		   in = again(in);//calls (in) to determine repeat status
			   return(in); // returns to menu function

}//end of parent_years function


/*Function to compute the future value.
   pre: present, interest, future (all passed from parent_future function)
   post: answer (returned to parent_future function)
*/

float tomorrow(float present, float interest, float years)
{//begin of tommorrow
float answer;//local variable
//clrscr();//clears the screen
answer = present * pow (1 + interest / 100, years);//computes future value
return (answer);
}//end of tommorow


/*Function to compute the present value.
   pre: future, interest, years (all passed from parent_present)
   post: answer (passed back to parent_present)
*/

float today(float future, float interest, float years)//computes present value

{//begin of today
float answer; //local variable declaration
//clrscr();//clears the screen
answer = future / pow (1 + interest / 100, years);//computes present value
return (answer);
}//end of today


/*Function to compute the value of percent.
   pre: future, present, years (passed from parent_interest)
   post: answer (returned to parent_interest)
*/
float percent_interest(float present, float future, float years)//computes interest

{//begin of percent
float result, reciprocal;//local variables
reciprocal = 1 / years;
//clrscr();//clear screen
result = (pow (future / present, reciprocal) -1) * 100;//computes interest
return (result);
}// end of percent_interest

/*Function to compute the number of years.
   pre: future, present, interest (passed from parent_years)
   post: answer (returned to parent_years)
*/

float number (float present, float interest, float future)//computes years
{//begin of number
float answer;//local variable
answer =log (future / present) / log (interest / 100 + 1);//computes years
return (answer);
}//end of number



/*Function to print the answer to the screen.-----------------------------------------
   Prints values used to compute the answer, plus the answer.----------------------
   pre: answer (passed from calling parent function)--------------------------------
   post: none*/


void print_ans (float answer, float present, float interest, float years, float future, char in_char) //prints output
{//begin of print
char print_char; //local char variable
//clrscr();//clears the screen
fflush(stdin);//flushes keyboard input buffer

switch (in_char)//case(#) is the ascii value of the input char taken from the menu function

	{//begin of switch to print output

	 case 102://prints the solution for future value
		 //clrscr();
		 printf("Solution for Future Value\n\n");
		 printf("Your present value is %.2f\n\n", present);
		 printf("The amount of interest is %.2f\n\n", interest);
		 printf("The amount of years is %.2f\n\n", years);
		 printf("Your future value is %.2f\n\n", answer);
		 break;

	 case 112://prints the solution for present value
		 //clrscr();
		 printf("Solution for Present Value\n\n");
		 printf("Your future value is %.2f\n\n", future);
		 printf("Your amount of interest is %.2f\n\n", interest);
		 printf("Your amount of years is %.2f\n\n", years);
		 printf("Your present value is %.2f\n\n", answer);
		 break;

	 case 105://prints the solution for interest rate
		 //clrscr();
		 printf("Solution for Interest Rate\n\n");
		 printf("Your present value is %.2f\n\n", present);
		 printf("Your future value is %.2f\n\n", future);
		 printf("Your amount of years is %.2f\n\n", years);
		 printf("Your interest rate is %.2f\n\n", answer);
		 break;

	 case 110://prints the solution for the number of years
		 //clrscr();
		 printf("Solution for the number of years\n\n");
		 printf("Your present value is %.2f\n\n", present);
		 printf("Your future value is %.2f\n\n", future);
		 printf("Your interest rate is %.2f\n\n", interest);
		 printf("Your number of years is %.2f\n\n", answer);
		 break;
	  }//end of switch in_char
 printf("\n\n\n\n\nPRESS ANY KEY TO CONTINUE\n");//prompts user
 print_char = getch();//user input (used to hold the screen)
//the following line of code provides a purpose for print_char in the program
//the character is printed, but never seen by the user
//the sole purpose of the variable is to hold the screen
//it has no revelance or impact to the rest of the program
 printf("%c", print_char);

}//end of print function


/*Function to determine if the user would like to repeat.-------------------------------------
   If the user wishes to exit it is done from this function.--------------------------------------
   Called from the menu function.---------------------------------------------------------------
   pre:in-------------------------------------------------------------------------------------------
   post: in*/


int again(int in)//offers the user a choice of repeating or exiting
{//begin of again

char repeat_char;//local variable

//clrscr();//clears the screen
fflush(stdin);//flushes keyboard input buffer
printf("Would you like to\n");//user prompt
printf("A.Repeat this same process\n");//user prompt
printf("B.Return to the main menu\n");//user prompt
printf("C.Exit the program\n");//user prompt
repeat_char = getch();//obtains user input

switch (repeat_char)//case(#) uses ascii values to represent input letter

       { //begin of switch, determined by repeat choice

	    case 97://(a) repeat the same computation
	    in = 1;//sets i to one to repeat while loop (b) in menu function
	    break;

	case 98://(b)return to main menu
	in = 0;//sets i to zero to test while loop (b) false in the menu function
	//while loop (a) in the menu function will test true (program restart)
	break;

	case 99://exit program
	exit(1);//exits program from this function
	break;
       } //end of switch

return(in);//returns value of in to the calling parent function

}//end of again function







